#include <system.h>
#include "Nokia3310.h"

rom char *NumFont={
	0x3e,0x41,0x41,0x3e,0x00,0x00,	//	0
	0x00,0x42,0x7f,0x40,0x00,0x00,	//	1
	0x62,0x51,0x49,0x46,0x00,0x00,	//	2
	0x22,0x49,0x49,0x36,0x00,0x00,	//	3
	0x18,0x14,0x12,0x7f,0x10,0x00,	//	4
	0x27,0x45,0x45,0x39,0x00,0x00,	//	5
	0x3e,0x49,0x49,0x32,0x00,0x00,	//	6
	0x01,0x71,0x0d,0x03,0x00,0x00,	//	7
	0x36,0x49,0x49,0x36,0x00,0x00,	//	8
	0x26,0x49,0x49,0x3e,0x00,0x00	//	9
};

rom char *ColonFont={
	0x00,0x66,0x66,0x00,0x00,0x00	//	:
};

rom char *TempFont={
	0x01,0x01,0x7f,0x01,0x01,0x00,	//	T
	0x38,0x54,0x54,0x54,0x08,0x00,	//	e
	0x78,0x04,0x38,0x04,0x78,0x00,	//	m
	0x00,0xfc,0x24,0x24,0x18,0x00	//	p
};

rom char *BuzzFont={
	0x18,0x42,0x3c,0x81,0x42,0x3c
};

void SpiInit()
{
	//SPI Init
	LCD_SCE=1;
	LCD_SCLK=0;
	LCD_RESET=0;
	sspstat=0xc0;	//SMP=1,CKE=1
	sspcon=0x20;	//20h=SPI CLK=FOSC/4=8.192KHz,CKP=0
	delay_ms(100);	//for Reset Pulse
	LCD_RESET=1;
}

void LcdWrite(char mode,char dat)
{
	LCD_INSTRUCTION=mode;
	LCD_SCE=0;	//sce assert
	SpiWrite(dat);//transmit data
	LCD_SCE=1;	//sce negate

}

void LcdInit(void)
{
	SpiInit();
	LCD_SCE=1;
	LCD_RESET=0;		//assert reset
	delay_ms(50);
	LCD_RESET=1;		//negate reset
	LcdWrite(0,0x21);
	LcdWrite(0,0x05);
	LcdWrite(0,0x13);
	LcdWrite(0,0xCB);
	LcdWrite(0,0x20);
	LcdWrite(0,0x0C);
	LcdWrite(0,0x40);
	LcdWrite(0,0x80);
	LcdCls();
}

void Lcd_Locate(unsigned char x, unsigned char y)
{
	LcdWrite(0,0x40|y);
	LcdWrite(0,0x80|x);

}

void LcdCls()
{
	int i;
	Lcd_Locate(0,0);
	LCD_INSTRUCTION=1;
	LCD_SCE=0;	//sce assert
	for(i=0;i<504;i++){
		if(i<84){
			//ŏ̍s
			SpiWrite(0x13);
		}else if(i>=420){
			SpiWrite(0xc8);
		}else{
			SpiWrite(0);
		}
	}
	LCD_SCE=1;	//sce assert
	Lcd_Locate(0,0);
}

void LcdPutnum(char c)
{
	//2̐\
	char d1,d2,i,pt;
	
	d1=c/10;
	d2=c%10;
	pt=d1*6;
	for(i=0;i<6;i++) {
		LcdWrite(1,NumFont[pt]);
		pt++;
	}
	pt=d2*6;
	for(i=0;i<6;i++) {
		LcdWrite(1,NumFont[pt]);
		pt++;
	}
}

void LcdColon()
{
	char i;
	for(i=0;i<6;i++) {
		LcdWrite(1,ColonFont[i]);
	}
}

void LcdTemp()
{
	char i;
	for(i=0;i<24;i++) {
		LcdWrite(1,TempFont[i]);
	}
}

void LcdBuzz(char flg)
{
	char i;
	
	for(i=0;i<6;i++) {
		if(flg)
			LcdWrite(1,BuzzFont[i]);
		else
			LcdWrite(1,0);
	}
}
